package com.example.demo.controller;

import com.example.demo.service.MemberService;
import com.example.demo.entity.Member;
import com.example.demo.dto.MemberDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.repository.query.Param;
import org.springframework.web.bind.annotation.*;
import com.google.gson.JsonParser;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.example.demo.constant.Role;


@RestController
public class MemberController {

    @Autowired
    MemberService memberService;

    public Member createMember(){
        MemberDto memberDto = new MemberDto();
        memberDto.setEmail("test@email.com");
        memberDto.setName("홍길동");
        memberDto.setAddress("서울시 마포구 합정동");
        memberDto.setPassword("1234");
        return Member.createMember(memberDto);
    }

    @RequestMapping(value = "/membertest", method = RequestMethod.GET)
    public void membertest(){

        Member member = createMember();
        Member savedMember = memberService.saveMember(member);

        System.out.println(member);
        System.out.println(savedMember);

    }

    @RequestMapping(value = "/makeMember", method = RequestMethod.POST)
    public String makeMember(@RequestBody String param){
    
        System.out.println(param);
        JsonElement element = JsonParser.parseString(param);
        JsonObject object = element.getAsJsonObject();
    
        String id = object.get("id").getAsString();
        System.out.println("id : " + id);
    
        String email = object.get("email").getAsString();
        System.out.println("email : " + email);
    
        String address = object.get("address").getAsString();
        System.out.println("address : " + address);
    
        String name = object.get("name").getAsString();
        System.out.println("name : " + name);
    
        String password = object.get("password").getAsString();
        System.out.println("password : " + password);
    
        Member member = new Member();
        member.setName(name);
        member.setEmail(email);
        member.setAddress(address);
        member.setPassword(password);
        member.setRole(Role.USER);
    
        memberService.saveMember(member);
    
        return "OK";
    
    }


}
